/************************************************************************
** CHRISTOPHER KRATZ - CS460 - TOS DATA ENGINE CLASS DEFINITIONS  **
************************************************************************/

const SIZE_QUEUENAME	= 255;
const SIZE_AGENTNAME	= 255;
const SIZE_PIPENAME		= 255;
const SIZE_PROCESSNAME	= 255;
const SIZE_MESSAGE		= 255;
const SIZE_QUEUE		= 255;

struct cMessage
{
	int intSize;
	char * data;
	char * sender;
	int ServiceNumber;
};

class cQueue
{
private:
	int intSize;
	
	int intFront;
	int intBack;
	cMessage * Messages;
	
public:
	
	char name[SIZE_QUEUENAME];
	bool AddMessage(cMessage mess);
	bool RemoveMessage(cMessage& mess);
	int getLength();
	cMessage * GetMessage();
	
	cQueue(char * name, int size);
	~cQueue();
};

struct cClient
{
	char pipename[SIZE_PIPENAME];
	char agentname[SIZE_AGENTNAME];
	bool bServerRun;
	char processname[SIZE_PROCESSNAME];
};



class cDataEngine
{
private:
	//int intTableCnt;
	//cTable * Tables;
	int intQueueCnt;
	cQueue ** Queues;

	 
	/*
	void AddTable();
	void RemoveTable();
	void LockTable();
	void ReleaseTable();
	*/

	bool AddQueue(char * name, int size);
	void RemoveQueue(char * name);
	void LockQueue(char * name);
	void ReleaseQueue(char * name);
	
public:
	//void ExecuteCommand();
	bool PostMess(char * destination, char * from, char * data, int length, int ServiceNumber);

	//void PostMessage(int index, char * data, int lenght);
	
	int GetMess(char * name, char * from, char * data, int& length, int& ServiceNumber);

	//void GetMess(int index, char * data, int& length);
	
	//int GetMessagingIndex(char * clientname);


	cDataEngine();
	~cDataEngine();
	
};



	





	
	
	
	
	
	