/************************************************************************
** CHRISTOPHER KRATZ - CS460 - TOS DATA ENGINE CLASS DEFINITIONS  **
************************************************************************/

struct cMessage
{
	int intSize;
	char * data;
};

class cQueue
{
private:
	int intSize;
	
	int intFront;
	int intBack;
	cMessage * Messages;
	
public:
	
	char name[255];
	bool AddMessage(cMessage mess);
	bool RemoveMessage(cMessage& mess);
	int getLength();
	cMessage * GetMessage();
	
	cQueue(char * name, int size);
	~cQueue();
};

struct cClient
{
	char pipename[255];
	char agentname[255];
	bool bServerRun;
	char processname[255];
};



class cDataEngine
{
private:
	//int intTableCnt;
	//cTable * Tables;
	int intQueueCnt;
	cQueue ** Queues;

	 
	/*
	void AddTable();
	void RemoveTable();
	void LockTable();
	void ReleaseTable();
	*/

	bool AddQueue(char * name, int size);
	void RemoveQueue(char * name);
	void LockQueue(char * name);
	void ReleaseQueue(char * name);
	
public:
	//void ExecuteCommand();
	void PostMess(char * destination, char * data, int length);
	//void PostMessage(int index, char * data, int lenght);
	
	int GetMess(char * client, char * data, int& length);
	//void GetMess(int index, char * data, int& length);
	
	//int GetMessagingIndex(char * clientname);


	cDataEngine();
	~cDataEngine();
	
};



	





	
	
	
	
	
	