#include <afxwin.h>
#include <stdlib.h>
#include "dialogs.h"
#include "resource.h"
#include "track.h"
#include "KMP_CLIENT_API.h"
#include "TOS_API.h"


DCCSpeedTest::DCCSpeedTest(CWnd * wnd) : CDialog(IDD_DCC_TEST_SPEED, wnd)
{
	//CDialog::CDialog(IDD_DCC_TEST_SPEED, wnd);
}

void DCCSpeedTest::OnOK()
{
	CEdit* number = (CEdit*)GetDlgItem(IDC_DCC_TEST_SPEED);
	char buffer[255];
	number->GetWindowText(buffer, 125);
	value = atoi(buffer);

	CEdit* t = (CEdit*)GetDlgItem(IDC_TRAIN);
	t->GetWindowText(buffer, 125);
	train = atoi(buffer);

	CButton* b = (CButton*)GetDlgItem(IDC_BACK);
	direction = 1 - b->GetCheck();

	CDialog::OnOK();

}

/*#############################################################################*/
/*#############################################################################*/
/*#############################################################################*/

DCCSwitchTest::DCCSwitchTest(CWnd * wnd) : CDialog(IDD_DCC_TEST_SWITCH, wnd)
{
	//CDialog::CDialog(IDD_DCC_TEST_SPEED, wnd);


}

void DCCSwitchTest::OnOK()
{
	CEdit* number = (CEdit*)GetDlgItem(IDC_ADD);
	CButton * val = (CButton*)GetDlgItem(IDC_VAL);

	char buffer[255];
	number->GetWindowText(buffer, 125);
	add = atoi(buffer);

	
	value = val->GetCheck();


	CDialog::OnOK();

}




/*#############################################################################*/
/*#############################################################################*/
/*#############################################################################*/



DCCCab::DCCCab(CWnd * wnd, HANDLE pipe) : CDialog(IDD_DCC_CAB, wnd)
{
	//CDialog::CDialog(IDD_DCC_TEST_SPEED, wnd);

	p = pipe;
}

afx_msg void DCCCab::OnSend()
{
	CEdit * train = (CEdit *)GetDlgItem(IDC_TRAIN);
	CEdit * speed = (CEdit *)GetDlgItem(IDC_SPEED);
	CButton * forward = (CButton*)GetDlgItem(IDC_FORWARD);
	CButton * reverse = (CButton*)GetDlgItem(IDC_REVERSE);


	char ts[50];
	char ss[50];

	train->GetWindowText(ts, 50);
	speed->GetWindowText(ss, 50);

	unsigned long t = atoi(ts);
	unsigned long s = atoi(ss);

	bool f = (1 == forward->GetCheck());
	
	TOS_SetTrainSpeedDCC(t, s, f, p);
}


BEGIN_MESSAGE_MAP(DCCCab, CDialog)

	ON_COMMAND(IDC_SEND, OnSend)


END_MESSAGE_MAP()

/*#############################################################################*/
/*#############################################################################*/
/*#############################################################################*/

ResourceRequestTest::ResourceRequestTest(CWnd * wnd) : CDialog(IDD_TEST_RESOURCE, wnd)
{
	//CDialog::CDialog(IDD_DCC_TEST_SPEED, wnd);


}

void ResourceRequestTest::OnOK()
{
	CEdit* i = (CEdit*)GetDlgItem(IDC_ID);
	CEdit* o = (CEdit*)GetDlgItem(IDC_OWNER);
	CButton * tn = (CButton*)GetDlgItem(IDC_NODE);
	CButton * ts = (CButton*)GetDlgItem(IDC_SECTION);

	char buffer[255];
	i->GetWindowText(buffer, 125);
	id = atoi(buffer);

	o->GetWindowText(buffer, 125);
	owner = atoi(buffer);

	
	/* 1 - is section */
	/* 2 - is node    */

	if(tn->GetCheck() == 1)
	{
		type = 2;
	}
	else
	{
		type = 1;
	}

	CDialog::OnOK();

}

/*#############################################################################*/
/*#############################################################################*/
/*#############################################################################*/

AddTrainDlg::AddTrainDlg(CWnd * wnd) : CDialog(IDD_ADD_TRAIN, wnd)
{
	//CDialog::CDialog(IDD_DCC_TEST_SPEED, wnd);


}

void AddTrainDlg::OnOK()
{
	CEdit* i = (CEdit*)GetDlgItem(IDC_ID);


	char buffer[255];
	i->GetWindowText(buffer, 125);
	id = atoi(buffer);

	CDialog::OnOK();

}

