/*#############################################*/
/* Kratz Multi-process system, API test agents */
/* this program is desinged to test and help   */
/* develope the multi-process server system    */
/* This Client Connects to the server and asks */
/* for messages that it has been sent          */
/***********************************************/
/*                   |:::::::::: _ ::::::::::: */
/*                   |::::::::  / \.  :::::::: */
/*                   |     .-----.  \   :::::: */
/*                   |    / \*****\  ", :::::: */
/*--:,:----:,:----_____ ,"   ",****", | :::::: */
/*  :|:    :|:   (_____)|     |*****| | :::::: */
/*                     /|TEST |*****| | :::::: */
/*                   ," |     |*****| | :::::: */
/*__________________/   ",   ,"****," | :::::: */
/*                   |::  \ /*****/  ," :::::: */
/*                   |:::  "-----"  /  ::::::: */
/*                   |:::::::::: \_"  :::::::: */
/***********************************************/


//#include <afxwin.h>
//#include <process.h>
#include <windows.h>
#include <signal.h>
#include <iostream.h>
#include <io.h>
#include <conio.h>

#include "kmp_client_api.h"

int main(int argc, char * argv[])
{

	cerr << "Client Started...\n";

	char pipename[30];
	strcpy(pipename, "\\\\.\\pipe\\Agent2");
	
	cerr << "Wait for named pipe...\n";

	HANDLE pipe = ConnectToServer(pipename);

	char message[CLIENT_SIZE_MESSAGE];
	
	char buffer[CLIENT_SIZE_BUFFER];

	unsigned long bytes = 0;
	while(true)
	{
		cerr << "Press any key to get Message: \n\n";
		getch();
		
		char from[255];
		unsigned long servicecode;
		unsigned long length;

		int ret = GetMessageFromPeer(from, servicecode, buffer, length, pipe);
		
		if(ret >= 0)
		{
			/* Service code 1 text message */
			buffer[length] = 0;
			strncpy(message, buffer, length+1);

			cerr << "From: " << from << "\n";
			cerr << "Service Code: " << servicecode << "\n";
			cerr << "Message Recieved: " << message << "\n";
			cerr << "Messages Remaining In queue: " << ret << "\n\n";
		}
		else if(ret == -1)
		{
			cerr << "No messages in queue.\n\n";
		}
		else if(ret < -1)
		{
			cerr << "Messaging Error.\n\n";
		}


	}

	return 0;

}

/*####################################################################################*/
/*                                                                                    */
/*    %%%%  %%%%   %%%%%%%    %%%%%%%%%  %%%%%%%%%  %%%%%%%%%                         */
/*    %%%%  %%%%   %%%%%%%%   %%%   %%%  %%%%%%%%%  %%%%%%%%%                         */
/*   %%%%%%%%     %%%%  %%%  %%%%%%%%%     %%%        %%%%%                           */
/*   %%%%%%%%     %%%%%%%%   %%%%%%%%%     %%%      %%%%                              */
/*  %%%%  %%%%   %%%% %%%   %%%   %%%     %%%     %%%%%%%%%                           */
/*  %%%%  %%%%   %%%  %%%%  %%%   %%%     %%%     %%%%%%%%%                           */
/*                                                                                    */
/*      #######   ####    ####    ########       ****     ***     ***    ******       */
/*     #########  #####   ####   ##########     ******   *****   *****   *******      */
/*    ####        ######  ####  ####    ###          *  **   ** **   **       **      */
/*    ####        ######  ####  ####               **   **   ** **   **      **       */
/*     #######    ####### ####  ####              **    **   ** **   **     **        */
/*      #######   ############  ####            ******   *****   *****     **         */
/*          ####  #### #######  ####            ******    ***     ***     **          */
/*          ####  ####  ######  ####    ###                                           */
/*    #########   ####   #####   ##########      -- ---  !  ! !    +--+               */
/*     #######    ####    ####    ########      |   ",   +--! !--+ |  |               */
/*                                               -- --"     ! !__! +--+               */
/*####################################################################################*/

